
import GameLogic
from math import pi
from  mathutils import Euler

# Get owner
controller = GameLogic.getCurrentController()
owner = controller.owner

# Get obj
scene = GameLogic.getCurrentScene()
objList = scene.objects
blob1 = objList["Blob1"]
blob2 = objList["Blob2"]
blob3 = objList["Blob3"]
blob4 = objList["Blob4"]
saber_magenta = objList["Saber_Magenta"]
empty1 = objList["Empty.001"]

def obj_orientation(obj,alpha,beta,gamma):
    '''Set obj orientation'''
    alpha = alpha*pi/180
    beta = beta*pi/180
    gamma = gamma*pi/180
    rot_en_euler = Euler([alpha,beta,gamma])
    obj.worldOrientation = rot_en_euler.to_matrix()

# Get new
mpPitch_0 = GameLogic.mpPitch_0
mpRoll_0 = GameLogic.mpRoll_0
mpYaw_0 = GameLogic.mpYaw_0

X = GameLogic.X
Y = GameLogic.Y
Z = GameLogic.Z

mpPitch = GameLogic.mpPitch
mpRoll = GameLogic.mpRoll
mpYaw = GameLogic.mpYaw

mpPitchSlow = GameLogic.mpPitchSlow
mpRollSlow = GameLogic.mpRollSlow
mpYawSlow = GameLogic.mpYawSlow

a = GameLogic.a
b = GameLogic.b
home = GameLogic.home

ir = GameLogic.ir

allData = GameLogic.allData

# Add new target
one = GameLogic.one
if one == 1:
    empty1['one']=True
else:
    empty1['one']= False

################################################################################
#---Set blue saber orientation, position-----------#
# Set fast mode if Slow = 0
if mpPitchSlow==0:
    kPitch = 0.042*4.65
else:
    kPitch = 0.042
if mpRollSlow==0:
    kRoll = 0.042*4.65
else:
    kRoll = 0.042
if mpYawSlow==0:
    kYaw = 0.042*4.65
else:
    kYaw = 0.042

# Set diiff with average value
mpPitch = mpPitch-mpPitch_0
mpRoll = mpRoll-mpRoll_0
mpYaw = mpYaw-mpYaw_0

# Set angle to move on local axis
alpha = mpPitch * kPitch*0.04
beta = mpRoll * kRoll*0.04
gamma = mpYaw * kYaw*0.04

# set amount to rotate
rotation = [-alpha*pi/360,-beta*pi/360,gamma*pi/360]

# move game object, true for local axis
owner.applyRotation(rotation, True)

# Set angle for display scene
world_angle = owner.localOrientation.to_euler()
alpha = 40*world_angle[0]
beta = 40*world_angle[1]
gamma = 40*world_angle[2]

# Set position with acc
x = 0.01*X-1.0
y = 0.05*Y - 6.4
z = 0.01*Z -0.5
owner.worldPosition = (x,y,z)

#---Center with a-----------#
if a:
    obj_orientation(owner,0,0,0)

################################################################################
#---Set saber_magenta orientation, position-----------#
x1 = 0.01*X-2.5
y1 = 0.01*Y - 1.8
z1 = 0.01*Z -0.5

# Set orientation saber_magenta with script angles
saber_magenta.worldPosition = (x1,y1,z1)
if b:
    obj_orientation(saber_magenta,0,0,0)

mpPitch = (allData[0]+allData[6])/2
mpRoll = (allData[1]+allData[7])/2
mpYaw = (allData[2]+allData[8])/2
mpPitchSlow = (allData[3]+allData[9])/2
mpRollSlow = (allData[4]+allData[10])/2
mpYawSlow = (allData[5]+allData[11])/2

# Set fast mode if Slow = 0
if mpPitchSlow==0:
    kPitch = 0.042*4.65
else:
    kPitch = 0.042
if mpRollSlow==0:
    kRoll = 0.042*4.65
else:
    kRoll = 0.042
if mpYawSlow==0:
    kYaw = 0.042*4.65
else:
    kYaw = 0.042

# Set diiff with average value
mpPitch = mpPitch-mpPitch_0
mpRoll = mpRoll-mpRoll_0
mpYaw = mpYaw-mpYaw_0

# Set angle to move on local axis
alpha_magenta = mpPitch * kPitch*0.04
beta_magenta = mpRoll * kRoll*0.04
gamma_magenta = mpYaw * kYaw*0.04

# set amount to rotate
rotation = [-alpha_magenta*pi/360,-beta_magenta*pi/360,gamma_magenta*pi/360]

# move game object, true for local axis
saber_magenta.applyRotation(rotation, True)

# Set angle for display scene
world_angle = saber_magenta.localOrientation.to_euler()
alpha_magenta = 40*world_angle[0]
beta_magenta = 40*world_angle[1]
gamma_magenta = 40*world_angle[2]

################################################################################
#---Set ir cube position----------------------#

if len(ir)>0:
    blob1X=ir[0][0]
    blob1Y=ir[0][1]
    blob2X=ir[1][0]
    blob2Y=ir[1][1]
    blob3X=ir[2][0]
    blob3Y=ir[2][1]
    blob4X=ir[3][0]
    blob4Y=ir[3][1]

irkx=-426
irky=-270
ax=1.2
ay=3.12
az=2.5

blob1.worldPosition = (1.6*(blob1X/irkx+ax),ay,blob1Y/irky+az)
blob2.worldPosition = (1.6*(blob2X/irkx+ax),ay,blob2Y/irky+az)
blob3.worldPosition = (1.6*(blob3X/irkx+ax),ay,blob3Y/irky+az)
blob4.worldPosition = (1.6*(blob4X/irkx+ax),ay,blob4Y/irky+az)

# Recenter with IR
if 200<blob1X<800 and 200<blob2X<800 and 200<blob3X<800 and 200<blob4X<800 and 300<blob1Y<500 and 300<blob2Y<500 and 300<blob3Y<500 and 300<blob4Y<500:
    if len(ir)==4:
        aver_x = -(blob1Y+blob2Y+blob3Y+blob4Y)/40
        aver_y = 0
        aver_z = (blob1X+blob2X+blob3X+blob4X)/40
        #print('Recenter',aver_x+42,aver_y,aver_z-45)
        obj_orientation(owner,aver_x+42,aver_y,aver_z-45)

################################################################################
#---Store for display scene-------------------#
GameLogic.alpha = alpha
GameLogic.beta = beta
GameLogic.gamma = gamma

GameLogic.alpha_magenta = alpha_magenta
GameLogic.beta_magenta = beta_magenta
GameLogic.gamma_magenta = gamma_magenta

