#!/usr/bin/python2

import cwiid
import sys
import os
import OSC
import threading

# Put your mac adress here
mac = '00:17:ab:2c:f2:57'

# tupple with ip, port. i dont use the () but maybe you want
send_address = '127.0.0.1', 9000
receive_address = '127.0.0.1', 9001

# OSC basic client
c = OSC.OSCClient()
c.connect(send_address) # set the address for all following messages
osc_bundle = OSC.OSCBundle()

global allData
allData = []

#------OSC Server-------------------------------------#
receive_address = '127.0.0.1', 9001

# OSC Server. there are three different types of server. 
s = OSC.ThreadingOSCServer(receive_address)

# this registers a 'default' handler (for unmatched messages)
s.addDefaultHandlers()

# define a message-handler function for the server to call.
def printing_handler(addr, tags, stuff, source):
    if addr=='/rumble':
        print "Rumble"
        #wiimote.rumble = wiimote.state['rumble'] = 1
        if stuff[0]==1:
            wiimote.rumble = 1
            wiimote.rumble = 0

s.addMsgHandler("/rumble", printing_handler)

btn_dict={'one':0,'two':0,'plus':0,'minus':0,'home':0,'a':0,'b':0,'left':0,
'right':0,'up':0,'down':0}
btn_set={1:'two',2:'one',4:'b',8:'a',16:'minus',128:'home',256:'left',
512:'right',1024:'down',2048:'up',4096:'plus'}

def main():

    # Start OSCServer
    print "Starting OSCServer"
    global st
    st = threading.Thread(target=s.serve_forever)
    st.start()
    global wiimote
    connect_wiimote()
    #Print help text ont startup
    print 'Confirm each command with ENTER.'
    hlpmsg =    'Press q to quit'
    print hlpmsg
    #Main loop for user interaction
    doLoop = True
    while doLoop:
        c = sys.stdin.read(1)
        if c == 'b':    # battery status
            state = wiimote.state
            bat = int(100.0 * state['battery'] / cwiid.BATTERY_MAX)
            print bat
        elif c == 'l':  # toggle led
            toggle_led()
        elif c == 'q':  # exit program
            doLoop = False
        elif c == '\n': # ignore newlines
            pass
        else:           # print help message when no valid command is issued
            print hlpmsg
    #Close connection and exit
    the_end()

def connect_wiimote():
    """Connets your computer to a Wiimote."""
    print 'Put Wiimote in discoverable mode now (press 1+2)...'
    global wiimote
    while True:
        try:
            wiimote = cwiid.Wiimote(mac)
            break
        except:
            continue
    wiimote.mesg_callback = callback

    #Set Wiimote options
    wiimote.rpt_mode=cwiid.RPT_ACC|cwiid.RPT_MOTIONPLUS|cwiid.RPT_BTN|cwiid.RPT_IR|cwiid.RPT_NUNCHUK|cwiid.RPT_STATUS# |cwiid.RPT_EXT
    wiimote.enable(cwiid.FLAG_MOTIONPLUS)
    wiimote.enable(cwiid.FLAG_MESG_IFC)

def callback(mesg_list, time):
    for mesg in mesg_list:
        if mesg[0] == cwiid.MESG_ACC:
            m1 = OSC.OSCMessage('/X')
            m1.append(mesg[1][0])
            osc_bundle.append(m1)

            m2 = OSC.OSCMessage('/Y')
            m2.append(mesg[1][1])
            osc_bundle.append(m2)

            m3 = OSC.OSCMessage('/Z')
            m3.append(mesg[1][2])
            osc_bundle.append(m3)

        elif mesg[0] == cwiid.MESG_BTN:
            btn = mesg[1]
            btn_activ=[]
            for i in reversed(range(13)):
                if btn//2**i==1:
                    btn=btn%2**i
                    btn_activ.append(2**i)
            for key in btn_dict.keys():
                btn_dict[key]=0
            if btn_activ!=[]:
                for i in range(len(btn_activ)):
                    btn_dict[btn_set[btn_activ[i]]]=1

        elif mesg[0] == cwiid.MESG_IR:
            m1 = OSC.OSCMessage('/ir')
            for src in mesg[1]:
                if src:
                    m1.append(src['pos'])
            #print m1
            osc_bundle.append(m1)

        elif mesg[0] == cwiid.MESG_NUNCHUK:
            m1 = OSC.OSCMessage('/nc-btn')
            m1.append(mesg[1]['buttons'])
            osc_bundle.append(m1)

            m2 = OSC.OSCMessage('/nc-stick')
            m2.append(mesg[1]['stick'])
            osc_bundle.append(m2)
            #print mesg[1]['stick']

            m3 = OSC.OSCMessage('/nc-accX') 
            m3.append(mesg[1]['acc'][cwiid.X])
            osc_bundle.append(m3)

            
            m4 = OSC.OSCMessage('/nc-accY')
            m4.append(mesg[1]['acc'][cwiid.Y])
            osc_bundle.append(m4)

            m5 = OSC.OSCMessage('/nc-accZ')
            m5.append(mesg[1]['acc'][cwiid.Z])
            osc_bundle.append(m5)

        elif mesg[0] == cwiid.MESG_MOTIONPLUS:
            m1 = OSC.OSCMessage('/mp-pitch')
            mpp = mesg[1]['angle_rate'][0]
            m1.append(mpp)
            osc_bundle.append(m1)

            m2 = OSC.OSCMessage('/mp-roll')
            mpr = mesg[1]['angle_rate'][1]
            m2.append(mpr)
            osc_bundle.append(m2)

            m3 = OSC.OSCMessage('/mp-yaw')
            mpy = mesg[1]['angle_rate'][2]
            m3.append(mpy)
            osc_bundle.append(m3)

            m4 = OSC.OSCMessage('/mp-pitch-slow')
            ps = mesg[1]['low_speed'][0]
            m4.append(ps)
            osc_bundle.append(m4)

            m5 = OSC.OSCMessage('/mp-roll-slow')
            rs = mesg[1]['low_speed'][1]
            m5.append(rs)
            osc_bundle.append(m5)

            m6 = OSC.OSCMessage('/mp-yaw-slow')
            ys = mesg[1]['low_speed'][2]
            m6.append(ys)
            osc_bundle.append(m6)

            # store 3 values
            if len(allData) < 2:
                allData.append([mpp,mpr,mpy,ps,rs,ys])
            if len(allData) == 2:
                del allData[0]
                allData.append([mpp,mpr,mpy,ps,rs,ys])
            #print allData
            
            m = OSC.OSCMessage('/all-data')
            m.append(allData)
            osc_bundle.append(m)

            # Send btn state every loop despite nothing change to store state 
            m7 = OSC.OSCMessage('/btn_dict')
            m7.append(btn_dict)
            osc_bundle.append(m7)

            try:
                # Send Bundle
                c.send(osc_bundle)
            except:
                pass
            # Reset bundle
            osc_bundle.clearData()

        elif mesg[0] ==  cwiid.MESG_ERROR:
            print "Error message received"
            global wiimote
            wiimote.close()
            exit(-1)
        else:
            print 'Unknown Report'

def the_end():
    #global wiimote
    wiimote.close()
    #st.shutdown() big pb
    sys.exit(0)

main()
